Ext.define('DSS.editor.CombinedNamesControl', {
	extend : 'DSS.component.Base',
	mixins : {
		observable : 'Ext.util.Observable'
	},
	getHeight : function() {
		return 54;
	},
	constructor : function(config) {		
		var me=this;
		this.nameControl=Ext.create("DSS.component.Textedit",{			            
            fieldLabel : _('Name'),
    		labelWidth:80,
            allowBlank : false,
            blankText : _('This field is required'),
            invalidText : _('The value in this field is invalid'),
            width : 370,
            inputWidth : 250,
		});

		this.setNameControl=Ext.create("DSS.component.Textedit",{
			fieldLabel :_('State description if set'),
    		labelWidth:200,
            allowBlank : false,
            blankText : _('This field is required'),
            invalidText : _('The value in this field is invalid'),
            width : 370,
            inputWidth : 150,
		});
		this.resetNameControl=Ext.create("DSS.component.Textedit",{
			fieldLabel :_('State description if not set'),
    		labelWidth:200,
            allowBlank : false,
            blankText : _('This field is required'),
            invalidText : _('The value in this field is invalid'),
            width : 370,
            inputWidth : 150,
		});
		this.operationSelector=Ext.create('Ext.form.RadioGroup',{
			fieldLabel:_('Operator'),
			vertical: true,
			width:370,
			hidden:true,
			items: [
		            { boxLabel: _('OR'), name: 'operator', inputValue: 'or' },
		            { boxLabel: _('AND'), name: 'operator', inputValue: 'and', checked: true}]
		});
		this.placeholder=Ext.create('Ext.form.field.Display', {
            value:''
        });
		Ext.apply(this, {
        	border: 0,
  			items : [ this.nameControl,this.setNameControl,this.operationSelector,this.placeholder,this.resetNameControl ],
  			height: 54,
  			width:740,
  			layout: {
  				type: 'table',
  				columns:2
  			}
  		});
		
		this.callParent(arguments);
	},
	reset : function() {
		this.nameControl.reset();
		this.setNameControl.reset();
		this.resetNameControl.reset();
		this.nameControl.setValue(this.dssEditor.editControls['name'].getValue());
		this.setNameControl.setValue(this.dssEditor.editControls['setName'].getValue());
		this.resetNameControl.setValue(this.dssEditor.editControls['resetName'].getValue());
	},
	isValid : function() {	
		this.dssEditor.editControls['name'].setValue(this.nameControl.getValue());
		this.dssEditor.editControls['setName'].setValue(this.setNameControl.getValue());
		this.dssEditor.editControls['resetName'].setValue(this.resetNameControl.getValue());
		var fValid=true;
		fValid &=this.nameControl.isValid();
		fValid &=this.setNameControl.isValid();
		fValid &=this.resetNameControl.isValid();
		
		return fValid;
	},
	setValue : function(oValue) {		
		this.nameControl.setValue(this.dssEditor.editControls['name'].getValue());
		this.setNameControl.setValue(this.dssEditor.editControls['setName'].getValue());
		this.resetNameControl.setValue(this.dssEditor.editControls['resetName'].getValue());
	},
	getValue : function() {
		this.dssEditor.editControls['name'].setValue(this.nameControl.getValue());
		this.dssEditor.editControls['setName'].setValue(this.setNameControl.getValue());
		this.dssEditor.editControls['resetName'].setValue(this.resetNameControl.getValue());
	}
});